// BTreeBuffer.cpp: implementation of the BTreeBuffer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "Buffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "Buffer.h"
#include "Except.h"
#include <iostream>

STRING char2str( const char * input, int count, char delim)
{
	STRING retval;

	for(int go = 0;go < count && input[go] != delim;go++)
		retval += input[go];

	return retval;
}


BTreeBuffer::BTreeBuffer( Cache * cache, char type, AvailHandler * availhandler, char fieldterm, char recterm)
	:Buffer( cache, type, availhandler, fieldterm, recterm)
{
}

STRING BTreeBuffer::unpack( OFFSET location)
{
	STRING mustunpacked;
	STRING buffer;

//	std::cout<<"alo"<<std::endl;
	cache->read( type, location, buffer);

	int i = 0;
	int n = 0;
	mustunpacked += buffer[i++];
	mustunpacked += buffer[i++];
	mustunpacked += buffer[i++];
	mustunpacked += buffer[i++];
	n = buffer[i-1];
	mustunpacked += buffer[i++];
	for (int j=0;j < n; j++)
	{
		mustunpacked += buffer[i++];
		int t=buffer[i-1];
		for(int k=0 ; k<t ; k++)
			mustunpacked += buffer[i++];
		mustunpacked += buffer[i++];
		mustunpacked += buffer[i++];
		mustunpacked += buffer[i++];
		mustunpacked += buffer[i++];
		mustunpacked += buffer[i++];
		mustunpacked += buffer[i++];
	}

	return mustunpacked;
}

void BTreeBuffer::remove( OFFSET location, int size)
{
	STRING temp;
	temp.resize(size + 1);
	cache->write( type, location, temp);
}
