// FileHasOpened.cpp : implementation file
//

#include "stdafx.h"
#include "mfc.h"
#include "FileHasOpened.h"
#include "InputForm.h"
#include "Manager.h"
#include "GetKey.h"
#include "MainFrm.h"
#include "direct.h"
#include "GetImPath.h"
#include "ExportDlg.h"

STRING mfcstr2str(CString what);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern PERSONLIST persons;
extern Manager * mymanager;
extern CMainFrame * allpapa;
extern STRLIST		mylines;


/////////////////////////////////////////////////////////////////////////////
// FileHasOpened dialog


FileHasOpened::FileHasOpened(CWnd* pParent, CString what)
	: CDialog(FileHasOpened::IDD, pParent)
{
	//{{AFX_DATA_INIT(FileHasOpened)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	this->what = what;
}

FileHasOpened::~FileHasOpened()
{
	delete mymanager;
	_chdir( "..");
}

BOOL FileHasOpened::OnInitDialog()
{
	GetDlgItem(IDC_STATIC_FileName)->SetWindowText( what);

	return TRUE;
}


void FileHasOpened::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FileHasOpened)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(FileHasOpened, CDialog)
	//{{AFX_MSG_MAP(FileHasOpened)
	ON_BN_CLICKED(IDADD, OnAdd)
	ON_BN_CLICKED(IDRemove, OnRemove)
	ON_BN_CLICKED(IDFind, OnFind)
	ON_BN_CLICKED(IDChange, OnChange)
	ON_BN_CLICKED(IDReport, OnReport)
	ON_BN_CLICKED(IDImport, OnImport)
	ON_BN_CLICKED(IDExport, OnExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// FileHasOpened message handlers

void FileHasOpened::OnOK() 
{
	try
	{	
//		delete mymanager;
		CDialog::OnOK();
//		_chdir( "..");
	}
	catch(Except & e)
	{
		MessageBox( e.message.c_str(), "Error", MB_ICONHAND);
	}
	catch(...)
	{
	}
}

void FileHasOpened::OnAdd() 
{	
	CClientDC dc (this);
	CInputForm Dlg(this, 1);

	Dlg.DoModal();
	
	allpapa->linesflash();
	Person tempp = *(persons.begin());
	mymanager->add( &tempp);
	persons.resize( 0);
}

void FileHasOpened::OnRemove() 
{
	CClientDC dc (this);
	GetKey Dlg(this);
	STRING mykey;
	int mode;

	if(Dlg.DoModal() == IDOK)
	{
		mykey = Dlg.m_keyforfind;
		mode = Dlg.m_whatiskey;
	}

	allpapa->linesflash();
	mymanager->remove( mykey, mode, this);
	allpapa->Invalidate( FALSE);	
}

void FileHasOpened::OnFind() 
{
	CClientDC dc (this);
	GetKey Dlg(this);
	STRING mykey;
	int mode;

	if(Dlg.DoModal() == IDOK)
	{
		mykey = Dlg.m_keyforfind;
		mode = Dlg.m_whatiskey;
	}

	allpapa->linesflash();

	persons.resize( 0);
	mymanager->getPersons( mykey, mode, persons);

	PERSONITTER it = persons.begin();
	PERSONITTER ite = persons.end();

	for(;it != ite;it++)
		it->tostring();

	allpapa->Invalidate( FALSE);	
}

void FileHasOpened::OnChange() 
{
	CClientDC dc (this);
	GetKey Dlg(this);
	STRING mykey;
	int mode;

	if(Dlg.DoModal() == IDOK)
	{
		mykey = Dlg.m_keyforfind;
		mode = Dlg.m_whatiskey;
	}

	allpapa->linesflash();
	mymanager->change( mykey, mode, this);
	allpapa->Invalidate( FALSE);		
}

void FileHasOpened::OnReport() 
{
	allpapa->linesflash();
	mymanager->inform();
	allpapa->Invalidate( FALSE);
}

void FileHasOpened::OnImport() 
{
	CClientDC dc (this);
	GetImPath Dlg(this);
	STRING mykey;

	if(Dlg.DoModal() == IDOK)
	{
		mykey = mfcstr2str( Dlg.m_path);
	}

	allpapa->linesflash();
	try
	{
		mymanager->import( mykey);
	}
	catch(Except & e)
	{
		MessageBox( e.message.c_str(), "Error", MB_ICONHAND);
	}
	allpapa->Invalidate( FALSE);		
}

void FileHasOpened::OnExport() 
{
	CClientDC dc (this);
	GetImPath Dlg(this);
	STRING mykey;

	if(Dlg.DoModal() == IDOK)
	{
		mykey = mfcstr2str( Dlg.m_path);
	}

	ExportDlg Dlg2(mykey.c_str(), this);

	while(Dlg2.DoModal() != IDCANCEL);

	allpapa->Invalidate( FALSE);		
}
