// Hash.h: interface for the Hash class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HASH_H__1292654F_45A6_48CB_8E50_5C2B83FE765C__INCLUDED_)
#define AFX_HASH_H__1292654F_45A6_48CB_8E50_5C2B83FE765C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef  __HASH_H_
#define  __HASH_H_

#include "Buffer.h"
#include "Cache.h"

class Hash
{
public:
	//Constructor
	Hash( Cache * cache, char type);
	~Hash();
	//Methods
	int getValue( int key);
	int addValue( int value, int key);
	void deleteValue( int key);
	//Static Methods
	static void packInt( STRING & buf, int value, int & place);
	static int unpackInt( STRING buf, int & place);
private:
	int hashCode( int key);
	int isEmpty( STRING str);

	HashBuffer buf;
	AvailHandler avail;
};	
#endif

#endif // !defined(AFX_HASH_H__1292654F_45A6_48CB_8E50_5C2B83FE765C__INCLUDED_)
