// HashBuffer.cpp: implementation of the HashBuffer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "Buffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "Buffer.h"
#include "Except.h"

HashBuffer::HashBuffer( Cache * cache, char type, AvailHandler *availhandler,char fieldterm, char recterm)
:Buffer( cache, type, availhandler, fieldterm, recterm)
{
	spacesize = SPACESIZE;
	bucketsize = BUCKETSIZE;
}

void HashBuffer::remove( OFFSET location, int size)
{
	STRING temp;
	temp.resize(size);
	cache->write( type, location, temp);
}

void HashBuffer::deadbucket( OFFSET location)
{
	if( location < spacesize * (bucketsize * sizeof(long) + sizeof(long)))
		throw Except("ERR:Trying to delete a primary bucket!!");

	availhandler->Add( (bucketsize * sizeof(long) + sizeof(long)), location);
}
